﻿@{
    ViewData["Title"] = "Home Page";
}
<!-- Button trigger modal -->

<button type="button" onclick="moduleClick()" class="btn btn-warning" data-bs-toggle="modal" data-bs-target="#staticBackdrop" style="position:absolute;top:10px; right:10px;">
   <span style="color:red;font-weight:600;display:none;" class="cartalert" >!</span> Cart
</button>

<!-- Modal -->
<div class="modal fade" id="staticBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true" >
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="staticBackdropLabel">Shopping Cart</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body" id="BoxCart">
                <table id="dtbox" class="table table-striped table-bordered" style="width:100%">
                    <thead>
                        <tr>
                            <th>Code</th>
                            <th>Name</th>
                            <th>Price/Unit</th>
                            <th>Pick Qty</th>
                            <th> </th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>
                            <td></td>
                            <td></td>
                            <td>สรุปยอด :</td>
                            <td id="txt_total"></td>
                            <td> </td>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <div class="modal-footer">
                <p style="color:forestgreen;display:none" id="show_checkout"><b>ตัดยอดสำเร็จ</b></p>
                <button type="button" class="btn btn-primary" id="btn-checkout" onclick="checkout()" >Checkout</button>
                <!--data-bs-dismiss="modal"-->
            </div>
        </div>
    </div>
</div>


<div class="text-center">
    <h2>Product</h2>
    <hr />
    <div class="row">
        <div class=" col-8">
        </div>
        <div class=" col-4" style="text-align:right">
            <a href="/Home/Edit" class="btn btn-success " > + Add</a>
        </div>
    </div>
        <div class="row" style="margin-top:15px;">
        
        <table id="dt" class="table table-striped table-bordered" style="width:100%">
            <thead>
                <tr>
                    <th>ProductID</th>
                    <th>ProductCode</th>
                    <th>ProductName</th>
                    <th>PricePerUnit</th>
                    <th width="120px">StockQty</th>
                    <th> </th>
                </tr>
            </thead>
            <tbody>
            </tbody>
        </table>
    </div>
</div>



@section Scripts {
 
    <script>
        $(document).ready(function () {
            loadCustomerData();
        });

        function moduleClick()
        {
            $(" .cartalert").hide();
        }

        function loadCustomerData() {
            $.ajax({

                url: 'api/Product', // Replace with your API URL
                type: 'GET',
                dataType: 'json',
                success: function (data) {
                    populateDataTable(data);
                },
                error: function (xhr, status, error) {
                    console.log(error);
                }
            });
        }
        function populateDataTable(data) {
            var table = $('#dt').DataTable({
                data: data,
                columns: [
                    { data: 'productId' },
                    {
                        data: null, render: function (data) {
                            var _Id = data.productId;
                            var _productCode = data.productCode;
                            return ("<span id='productCode_" + _Id + "' >" + _productCode + "</span>");
                        }
                    },
                    {
                        data: null, render: function (data) {
                            var _Id = data.productId;
                            var _productName = data.productName;
                            return ("<span id='productName_" + _Id + "' >" + _productName + "</span>");
                        }
                    },
                    {
                        data: null, render: function (data) {
                            var _Id = data.productId;
                            var _pricePerUnit = data.pricePerUnit;
                            return ("<span id='pricePerUnit_" + _Id + "' >" + _pricePerUnit + "</span>");
                        }
                    },
                    {
                        data: null, render: function (data) {
                            var _Id = data.productId;
                            var _stockQty = data.stockQty;
                            return ("<span id='stockQty_" + _Id + "' >" + _stockQty + "</span>");
                        }
                    },
                    { data: null,  render: function (data) {
                            var _Id = data.productId;
                            return ("<input id='Pick_" + _Id + "' class='from-control' style='width:100px' type='number'><a class='btn btn-warning' onclick='picking(" + _Id + ")' >+Cart</a> ");
                        }
                    }
                ]
            });
        }
        function picking(_Id) {
            var _stockQty = parseInt($("#stockQty_" + _Id).html());
            var _Pick = parseInt($("#Pick_" + _Id).val());
            if (_stockQty >= _Pick && _Pick !== 0) {
                if ($("#CartRow_" + _Id).length == 0) 
                {
                    var _Body = $("#BoxCart table").html() +
                        "<tr id='CartRow_" + _Id + "' class='CartRow'>" +
                        "<td>" + $("#productCode_" + _Id).html() + "</td>" +
                        "<td>" + $("#productName_" + _Id).html() + "</td>" +
                        "<td Class='CartRow_pricePerUnit'>" + $("#pricePerUnit_" + _Id).html() + "</td>" +
                        "<td > " + genbutton(_Id,_Pick) + "</td>" +
                        "<td><button class='btn-sm btn btn-danger' onclick='pickingdelete(" + _Id + ")' >Delete</button></td> " +
                        "</tr>";
                    $("#BoxCart table").html(_Body);
                    $("#stockQty_" + _Id).html((_stockQty - _Pick));
                    $("#Pick_" + _Id).val(0);
                }
                else{
                    $("#CartRow_Pick_" + _Id).val(parseInt($("#CartRow_Pick_" + _Id).val()) + _Pick);
                    $("#stockQty_" + _Id).html((_stockQty - _Pick));
                    $("#Pick_" + _Id).val(0);
                }
                $(".cartalert").show();
            }
            else
            {
                if (_Pick === 0)
                {
                    alert("กรุณาเลือกสินค้า");

                }
                else
                {
                    alert("จำนวณสินค้าไม่พอกับ Stock");

                }

            }
        }

        function genbutton(_Id, _Pick) {
            var res = "<div class='qty'>" +
                "<span class='minus bg-dark' onclick='picking_mi("+_Id+")'> -</span>" +
                      "<input type = 'number' readonly class='count CartRow_Pick' name ='qty' id='CartRow_Pick_" + _Id + "'  value = '" + _Pick + "' >" +
                "<span class='plus bg-dark' onclick='picking_plus(" + _Id + ")'> +</span>" +
                      "</div>" ;
            return res;     
        
        }

        function picking_mi(_Id) {

            var _stockQty = parseInt($("#stockQty_" + _Id).html());
            var _pickitem = parseInt($("#CartRow_Pick_" + _Id).val());
            if ((_pickitem - 1) < 0) {
                $("#CartRow_" + _Id).remove();
            }
            else
            {
                $("#stockQty_" + _Id).html(_stockQty + 1);
                $("#CartRow_Pick_" + _Id).val(_pickitem - 1);
            }
            
        }

        function picking_plus(_Id) {
            var _stockQty = parseInt($("#stockQty_" + _Id).html());
            var _pickitem = parseInt($("#CartRow_Pick_" + _Id).val());
            if ((_stockQty - 1) < 0) {
                alert("จำนวณสินค้าไม่พอกับ Stock");
            }
            else{
                $("#stockQty_" + _Id).html(_stockQty - 1);
                $("#CartRow_Pick_" + _Id).val(_pickitem + 1);
            }
        }

        function pickingdelete(_Id) {
            var _stockQty = parseInt($("#stockQty_" + _Id).html());
            var _pickitem = parseInt($("#CartRow_Pick_" + _Id).val());
            console.log(_stockQty + _pickitem);
            $("#stockQty_" + _Id).html(_stockQty + _pickitem);
            $("#CartRow_" + _Id).remove(); 
        }
        function checkout() {
            var total = 0;
            var res = "";
            if($('.CartRow').length > 0){
            $('.CartRow').each(function (i, obj) {
                var _CartRow_pricePerUnit = parseFloat($(obj).find(".CartRow_pricePerUnit").html());
                var _CartRow_Pick = parseFloat($(obj).find(".CartRow_Pick").val());
                total = total + ( _CartRow_pricePerUnit * _CartRow_Pick);
                res = res + $(obj).attr('id') + "," + _CartRow_Pick + "|";

            });
            $("#txt_total").html(total);
            $.ajax({
                url: '../api/Product', // Replace with your API URL
                type: 'Patch',
                data: {
                    "value": res
                },
                dataType: 'text',
                success: function (data) {
                        $("#show_checkout").show();
                        $("#btn-checkout").hide();
                        setTimeout(function () {
                            window.location.replace("/Home");
                        }, 3000);
                },
                error: function (xhr, status, error) {
                    // alert("Success");
                    //window.location.replace("/Home");
                }
            });
            }else{
                alert("กรุณาเลือก สินค้าก่อนทำ Check out");
            }
        }
    </script>
}